import java.util.*;

public enum EnumValues {

    HELP("help") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s is to be implemented%n", "\"help\"");
        }
    },
    INFO("info") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s is to be implemented%n", "\"info\"");
        }
    },
    LIST("list") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s is to be implemented%n", "\"list\"");
        }
    },
    INSTALL("install") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s is to be implemented%n", "\"install\"");
        }
    },
    DEPS("deps") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s is to be implemented%n", "\"deps\"");
        }
    },
    UNINSTALL("uninstall") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s is to be implemented%n", "\"uninstall\"");
        }
    },
    UPGRADE("upgrade") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s is to be implemented%n", "\"upgrade\"");
        }
    },
    UNKNOWN("unknown") {
        void execute(String repoFileName, String... params) {
            System.out.printf("%s command is unknown, usage:%n", "\"unknown\"");
            HELP.execute(repoFileName, params);
//            System.exit(1);
        }
    };

	private final String commandName;
	
	// Implementing a fromString method on an enum type
	private static final Map<String, EnumValues> stringToEnum
		= new HashMap<String, EnumValues>();
	static { // Initialize map from constant name to enum constant
	    for (EnumValues ev : values())
	        stringToEnum.put(ev.toString(), ev);
	}
	// Returns Operation for string, or null if string is invalid
	public static EnumValues fromString(String symbol) {
	    return stringToEnum.get(symbol);
	}
	

    abstract void execute(String repoFileName, String... params);

    EnumValues(String name) {
        this.commandName = name;
    }

    @Override
    public String toString() {
        return commandName;
    }

	public static void main(String[] args) {
		for (EnumValues ev: EnumValues.values()) {
			System.out.printf("%s is name of %b constant%n", ev, 
				EnumValues.fromString(ev.toString()));
		}
	}
}

